static asmlinkage int (*orig_capset)(cap_user_header_t, cap_user_data_t);

asmlinkage int hacked_capset(cap_user_header_t header, cap_user_data_t data)
  /* this is the def from capability.c - it is not ... (struct pt_regs regs) */
{
 printk(NOTIFY_LOG "SecuMod: capset [%.15s](UID %d) eff: %x inh: %x perm: %x\n",
        current->comm, current->uid,
        data->effective, data->inheritable, data->permitted);

 if (current->uid && !cap_raised(data->inheritable,CAP_SETUID))
 {
   if (logging) 
     secu_alert("tried to remove CAP_SETUID from inheritable set",NULL);
   return -EPERM; 
   // TODO: give the caller a chance: (probably have to copy data around???)
   // data->inheritable |= CAP_SETUID; but check if the correction has worked:
   // if (!cap_raised(data->inheritable,CAP_SETUID)) return -EFAULT;
 };
 return orig_capset(header,data); /* will this way of calling work? I believe it will. */
   // usually only original values work, NOT copies in kernel space,
   // because most syscalls check access rights of current (-> has none for kernel data) !
};


void cap_setuid_protection(int on)
{
 cap_setuid_protection_on=on;
 if (on)
 {
   orig_capset=sys_call_table[SYS_capset /* == __NR_capset */];
   sys_call_table[SYS_capset]=hacked_capset;
   sys_call_hooked[SYS_capset]=1;
 }
 else
 { 
   if (sys_call_hooked[SYS_capset]) sys_call_table[SYS_capset]=orig_capset; 
   sys_call_hooked[SYS_capset]=0;
 };
};
