#ifndef SM_CFG_OK
#define SM_CFG_OK

/*
                               CONFIGURATION FILE
*/

#undef PROC_INTERFACE	/* define to control trusted paths via /proc */
#define EXEC_LOGONLY	/* do not block if exec/suid is in wrong path */
#define DO_EXPORT_SYMBOLS

#define POSTFIX 51	/* UID of Postfix - pipes of this UID are NOT protected */

/* Number of /proc-loadable trusted and suid-protected pathes */
#define NR_TPATHS 30

/* those are never removed (only trusted for non-suid) */
/* HINT: if you want to sudo insmod, you have a problem w/o those */
static char *fixed_tpaths[] = 
  { "/bin", "/sbin", "/usr/bin", "/usr/sbin", "/usr/X11R6/bin", 
    "/opt/kde/bin", 
    "/usr/lib/gcc-lib" /* gcc */, 
    "/lib" /* ld.so */,
    "/usr/X11R6/lib" /* xdm, fvwm */,
    "/usr/local/bin:/", /* and possibly /usr/local/sbin */
#ifndef PROC_INTERFACE
    "/var/lib/dosemu","/usr/games",
    "/opt/gnome/bin","/usr/openwin/bin",
    "/var/home","/var/tmp",
    "/var/lib","/usr/lib","/usr/X11R6","/opt",
#endif
    NULL }; 
/* only keep first line (/bin ... /usr/X11R6/bin) when */
/* /proc works completely or binaries are sorted better */

static char *fixed_suidpaths[] = 
  { "/sbin",
#ifndef PROC_INTERFACE
    "/usr/sbin", /* maybe even /usr/local/sbin */
#endif
    NULL };

/* Some log-levels for the module */
#define START_LOG KERN_DEBUG
#define NOTIFY_LOG KERN_DEBUG
#define REAL_LOG KERN_ALERT
#define SOCK_LOG KERN_DEBUG

struct cap_sec_mode { char *desc;  kernel_cap_t cap_val; };

/*
  Here you can add your own entries for your own needs. The first value stands
  for the name of the cap_bset security level and the second for the actual
  value of cap_bset. For a description of possible cap_bset values see
  CAPBITS.HOWTO
*/
static struct cap_sec_mode cap_bset_modes[] = {
/* Bits 3,5,6,7,8,10,11,12,13,14,15,17,19,21,23,24,25,22 not set */
	{ "strict", 4229235223U},
/* Bits 3,8,9,13,16 not set */ /* Todo: maybe unset 12 (ipconfig) ? */
	{ "default", 4294892791U},
/* Bit 23 set; bear in mind that this is system is nearly usable ! */
	{ "paranoid", 8388608U},
/* Bit 9 not set */
	{ "desktop", 4294966783U},
		/* ericstrict entry is only for testing! */
/* Erics Auswahl, stoert Config-Edit (Bits 3,5, 8,9,12,13,15, 16,19.21 aus) */
	{ "ericstrict", 4292234455U}, /* FF.d6.4c.d7 */
	{ NULL, 0 }
};

/* Alle Bits an ist: 4 294 967 295 U; welches Bit beeinflusst was ->     */
/* 3owner 5sig (6setgid 7setuid) 8setcap 9chattr (10port<1k 11multicast) */
/* 12ipcfg 13rawsock (14shm) 15ipc 16insmod (17ioperm 18chroot) 19ptrace */
/* ((20pacct)) 21drivercfg ((22reboot)) (23renice 24resourcelimits)      */
/* (25clock) ((26ttycfg)) ((27,28,29,30 UNKNOWN)) ((31suserfallback))    */

#endif
