int (*orig_link)(const char *oldname, const char *newname);


// int do_link(const char * oldname, const char * newname);
// /* do_link cannot escape from fs/namei.c, very sad :-( */

// getname and putname: see linux/fs.h, putname == free_page((u.long)(name))
// code of getname is in fs/namei.c: do_getname does the bounds checking ->
// pointer has to be < TASK_SIZE unless segment_eq(get_fs(), KERNEL_DS)
// getname does a strncpy_from_user(...,...,min(PAGE_SIZE,TASK_SIZE-pointer))
// to a pointer found by __get_free_page(GFP_KERNEL)
// ### so, getname needs putname and is a cool way to fetch a string ###

int hacked_link(const char *oldname, const char *newname)
  /* from fs/namei.c - does not use (struct pt_regs regs) */
  /* changed to contain most of the code from sys_link ! */
{
	struct dentry *dent;
        int error;
        char * from;
        char * to;

        lock_kernel();
        
        from = getname(oldname); // evtl. besser regs?
        error = PTR_ERR(from);
        if (IS_ERR(from)) goto leave_l1; 
        // if getname returns an error, it has already freed the page!
        
	 to  = getname(newname); // evtl. besser regs?
        error = PTR_ERR( to );
        if (IS_ERR( to )) goto leave_l2;
        
	dent = open_namei(from, 0, 0); // oder: namei,lnamei(from//oldname) ?
	/* no longer trying namei before lnamei */
	if (IS_ERR(dent)) goto leave_l3;
	
	if ((dent->d_inode->i_uid != current->fsuid) 
	 && (current->uid != 0))
	/* TODO: entscheiden, ob das Verbot auch root betreffen soll */
	/* bei v1.5 betraf das Verbot auch root */
	{
		if (logging) secu_alert("tried to create hardlink to",from);
		error = -1;
	} else 
        {
                error = orig_link(oldname,newname); 
                /* need only do_link, but that is only avail. inside fs/namei.c */
                /* sad (races?) but true!?: must NOT use from,to (will get EFAULT else) */
	};

	dput(dent);	// NEW
	leave_l3:
	putname(to);
	leave_l2:
	putname(from);
	leave_l1:
	unlock_kernel();
	return error;
};


void hardlink_protection(int on)
{
	hardlink_protection_on = on;
	if (on) 
	{ 
		orig_link = sys_call_table[SYS_link];
		sys_call_table[SYS_link] = hacked_link;
		sys_call_hooked[SYS_link] = 1;
	} else 
	{ 
		if (sys_call_hooked[SYS_link])
			sys_call_table[SYS_link] = orig_link;
		sys_call_hooked[SYS_link] = 0;
	} ;
};
