int (*orig_sockcall) (int, unsigned long *);

/* Argument list sizes for sys_socketcall */
#define AL(x) ((x) * sizeof(unsigned long))
static unsigned char nargs[18] = {
	AL(0),AL(3),AL(3),AL(3),AL(2),AL(3),
	AL(3),AL(3),AL(4),AL(4),AL(4),AL(6),
	AL(6),AL(2),AL(5),AL(5),AL(3),AL(3)
};

#undef AL

static int hacked_sockcall(int call, unsigned long *args)
 /* everything is allowed - for logging only */
{
	unsigned long a[6];
	struct sockaddr_in sin_in;

	if (copy_from_user(a, args, nargs[call]))
		return -EFAULT;

	switch(call) {
		case SYS_CONNECT:
			copy_from_user(&sin_in, (void *)a[1], sizeof(struct sockaddr_in));
			if (sin_in.sin_family != AF_INET)
				return((*orig_sockcall)(call, args));

			if (logging)
				printk(SOCK_LOG "SecuMod: connect - Name: %s | UID: %u | EUID: %u | PID: %u | IP: %d.%d.%d.%d | Port: %hu\n",
				current->comm,
				current->uid,
				current->euid,
				current->pid,
				ntohl(sin_in.sin_addr.s_addr) >> 24 & 0xFF,
				ntohl(sin_in.sin_addr.s_addr) >> 16 & 0xFF,
				ntohl(sin_in.sin_addr.s_addr) >>  8 & 0xFF,
				ntohl(sin_in.sin_addr.s_addr) & 0xFF,
				ntohs(sin_in.sin_port));
			break;

		case SYS_ACCEPT:
			copy_from_user(&sin_in, (void *)a[1], sizeof(struct sockaddr_in));
			if (sin_in.sin_family != AF_INET)
				return((*orig_sockcall)(call, args));	
			if (logging)
				printk(SOCK_LOG "SecuMod: accept - Name: %s | UID: %u | EUID: %u | PID: %u | IP: %d.%d.%d.%d | Port: %hu\n",
				current->comm,
				current->uid,
				current->euid,
				current->pid,
				ntohl(sin_in.sin_addr.s_addr)>>24 & 0xFF,
				ntohl(sin_in.sin_addr.s_addr)>>16 & 0xFF,
				ntohl(sin_in.sin_addr.s_addr)>>8 & 0xFF,
				ntohl(sin_in.sin_addr.s_addr) & 0xFF,
				ntohs(sin_in.sin_port));
			break;

		case SYS_SHUTDOWN:
			if (logging)
				printk(SOCK_LOG "SecuMod: shutdown - Name: %s | UID: %u | EUID: %u | PID: %u\n",
				current->comm,
				current->uid,
				current->euid,
				current->pid);
			break;
	}

	return ((*orig_sockcall)(call, args));
};


void socket_protection(int on)
{
	socket_protection_on = on;
	if (on) 
	{
		orig_sockcall = sys_call_table[SYS_socketcall];
		sys_call_table[SYS_socketcall] = hacked_sockcall;
		sys_call_hooked[SYS_socketcall] = 1;
	} else 
	{ 
		if (sys_call_hooked[SYS_socketcall])
			sys_call_table[SYS_socketcall] = orig_sockcall;
		sys_call_hooked[SYS_socketcall] = 0;
	};
};
